/*! \file KML_Container.h 
 *  \brief: header file for kml_container abstract object
 */

#ifndef _KML_CONTAINER_H_
#define _KML_CONTAINER_H_

/*Headers:*/
/*{{{1*/
#include "../../include/include.h"
#include "../../shared/Exceptions/exceptions.h"
#include "../../EnumDefinitions/EnumDefinitions.h"

#include "./KML_Feature.h"
/*}}}*/

class KML_Container: public KML_Feature {

	public:

		/*KML_Container constructors, destructors {{{1*/
		KML_Container();
		~KML_Container();
		/*}}}*/
		/*Object virtual functions definitions:{{{1*/
		void  Echo();
		void  DeepEcho();
		void  DeepEcho(char* indent);
		void  Write(FILE* fid,char* indent);
		KML_Object*  Read(FILE* fid,char* kstr);
		int   Id();
		int   MyRank();
		void  Marshall(char** pmarshalled_dataset);
		int   MarshallSize();
		void  Demarshall(char** pmarshalled_dataset);
		int   Enum();
		Object* copy();
		/*}}}*/

};
#endif  /* _KML_CONTAINER_H */

